{ lib
, python3
, fetchPypi
, cargo
, rustPlatform
, rustc
}:

python3.pkgs.buildPythonPackage rec {
  pname = "pydantic-core";
  version = "2.10.1";
  pyproject = true;

  src = fetchPypi {
    pname = "pydantic_core";
    inherit version;
    hash = "sha256-D4aC290vZ/jh7d3L/8wp9gphgrSQHDZ/yMHEDTC7CoI=";
  };

  cargoDeps = rustPlatform.fetchCargoTarball {
    inherit src;
    name = "${pname}-${version}";
    hash = "sha256-wHiIVM0x+xH0SpP6UmlGh6r7sg0rnnppGrIchHTVJcc=";
  };

  nativeBuildInputs = [
    cargo
    python3.pkgs.typing-extensions
    rustPlatform.cargoSetupHook
    rustPlatform.maturinBuildHook
    rustc
  ];

  propagatedBuildInputs = with python3.pkgs; [
    typing-extensions
  ];

  pythonImportsCheck = [ "pydantic_core" ];

  meta = with lib; {
    description = "";
    homepage = "https://pypi.org/project/pydantic-core";
    license = licenses.mit;
    maintainers = with maintainers; [ ];
    mainProgram = "pydantic-core";
  };
}
