{ config, pkgs, ...}:
let
  host = "podcasts.dgnum.eu";
in
{
  # Notes:
  # le paramètre analytics.salt est créé par le service
  services.castopod = {
    enable = true;
    localDomain = host;
    environmentFile = config.age.secrets.castopod-environment_file.path;
    settings = {
      "email.fromEmail"="podcasts@infra.dgnum.eu";
      "email.SMTPHost"="kurisu.lahfa.xyz";
      "email.SMTPUser"="web-services@infra.dgnum.eu";
      "email.SMTPPort"="465";

      "media.fileManager"="s3";
      "media.s3.endpoint"="https://s3.dgnum.eu/";
      "media.s3.region"="garage";
      "media.s3.bucket"="castopod";
      "media.s3.pathStyleEndpoint"=true;

      "restapi.enabled"=true;
      "restapi.basicAuthUsername"="castopod";
      "restapi.basicAuth"=true;
    };
    database.createLocally = true;
    configureNginx = true;
  };
  services.mysql.package = pkgs.mariadb;
  services.nginx.virtualHosts.${host} = {
    forceSSL = true;
    enableACME = true;
  };
}
